' Another World Memory source code.
' Compiler: FreeBASIC.
' Relatively commented.

#include "fbgfx.bi"
#include "fmod.bi"
#include "pp256_image.bi"

DECLARE SUB About ()
DECLARE SUB AI ()
DECLARE SUB CardDisappearLayer ()
DECLARE SUB InitiateCardDisappear (CardDisappearX%, CardDisappearY%)
DECLARE SUB ClearCards ()
DECLARE SUB WaitForAWhile ()
DECLARE SUB PutText ()
DECLARE SUB InitVariables ()
DECLARE SUB DrawCards ()
DECLARE SUB Options ()
DECLARE SUB ClickBoxes2 ()
DECLARE SUB ClickInventory ()
DECLARE SUB DoGame ()
DECLARE SUB ClickBoxes ()
DECLARE SUB DoMenu ()
DECLARE SUB WriteHighScore ()
DECLARE SUB ReadHighScore (hfs)
DECLARE SUB InputName ()
DECLARE SUB neoENCpass (Offset%, Length&, password$)
DECLARE SUB neoENCdepass (Offsett%, Lengthh&, passsword$)


'Of course!!!!! :)
CONST FALSE = 0, TRUE = 1

TYPE CardType
Cleared AS INTEGER
Active AS INTEGER
Typ AS INTEGER
Xpos AS INTEGER
Ypos AS INTEGER
END TYPE
                               
TYPE CardDisappearType
Locked AS INTEGER
Exploding AS INTEGER
PosX AS INTEGER
PosY AS INTEGER
END TYPE

'***********************************************
' Variables and the sub used to load PUT files into arrays.
TYPE tileType
s_image	    as ImageType		
init	  	    as sub ( byref tile as tileType )	 
load_image   as sub ( byref tile as tileType )	  
END TYPE
DECLARE SUB tile_load_image ( byref tile as tileType )
DECLARE SUB tile_destroy_image ( byref tiled as tileType )
'***********************************************

' Subs used to print custom font text on the screen.
DECLARE SUB GraphicText (xx%, yy%, Textt$, byref tile as tileType)
DECLARE FUNCTION GetDepth% (ImNo%,byref tilem as tileType)
DECLARE FUNCTION GetWidth% (ImNo%,byref tilem as tileType)

' Arrays that will hold our sprites, tiles and our font.
DIM SHARED CursorSpr as tileType
DIM SHARED CardSpr as tileType
DIM SHARED Font1 as tileType
DIM SHARED Font2 as tileType

DIM SHARED Ypos, Frame2, mx, my, buttons, sshoot
DIM SHARED path$, EndGame, currentcursor, addtile
DIM SHARED Xstart, YStart, XMax, YMax, Activation, ActivationTime
DIM SHARED BluePoints, RedPoints, Seconds, Minutes, Card1, Card2
DIM SHARED PlaySound, FieldType, BackGroundType, numofcards, CountCards
DIM SHARED ActX1, ActY1, ActX2, ActY2, AIType, AISlowDown, FPS, FPS2, Turns
DIM SHARED Fieldsize$, FMODStatus
DIM SHARED starttime AS DOUBLE
DIM SHARED temptime AS DOUBLE
DIM SHARED playerletter$(8), playername$, milsec
DIM SHARED FPSCounter, ClickControl, soloreduce

' GameMode = 1 -> human vs computer
' GameMode = 2 -> human vs human
' GameMode = 3 -> solo challenge mode
' BlueRedTurn = 1 -> blue player is drawing
' BlueRedTurn = 2 -> red player is drawing
' CardOpenMode = 1 -> first card is drawn
' CardOpenMode = 2 -> second card is drawn
' CardOpenMode = 3 -> in this mode computer
' checks if the drawn cards are the same
' and executes some code according to this.
DIM SHARED GameMode, CardOpenMode, BlueRedTurn

' Card array stores the data about each card(its image, if
' it has been cleared, etc.).
DIM SHARED Card(8, 8) AS CardType

' AICard array is used to store the images of cards that
' have been turned over into AI memory so the AI can 
' use this data during a round.
DIM SHARED AICard(8, 8) AS CardType

DIM SHARED CardDisappear(5) AS CardDisappearType
DIM SHARED backimage(6, 64004) AS INTEGER
DIM SHARED mysamples(13) AS INTEGER PTR

pathf$ = ""

' Open the setup file and read if the program
' should start in full screen mode or not
' and if to use the FMOD routines.
OPEN pathf$ + "data/setup.dat" FOR INPUT AS #2
INPUT #2, FullScreen
INPUT #2, FMODStatus
CLOSE #2

SCREEN 13, 8, 2, FullScreen
SETMOUSE 0,0,0    ' We hide the deafult mouse cursor.
SCREENSET 1, 0    ' Set page 1 as the work page and 
                  ' page 0 as the visible page.
                  
' Load all the game graphics(backgrounds, fonts, card
' images, etc.).
BLOAD "Graphics/MAINMENU.bmp", 0
GET (0,0)-(319,199), backimage(1,0)
BLOAD "Graphics/BACKG1.bmp", 0
GET (0,0)-(319,199), backimage(2,0)
BLOAD "Graphics/BACKG2.bmp", 0
GET (0,0)-(319,199), backimage(3,0)
BLOAD "Graphics/BACKG3.bmp", 0
GET (0,0)-(319,199), backimage(4,0)
BLOAD "Graphics/BACKG4.bmp", 0
GET (0,0)-(319,199), backimage(5,0)
BLOAD "Graphics/BACKG5.bmp", 0
GET (0,0)-(319,199), backimage(6,0)

CursorSpr.s_image.m_filename = pathf$ + "Graphics/ACURSOR.PUT"
Tile_load_image ( CursorSpr )
CardSpr.s_image.m_filename = pathf$ + "Graphics/CARDS.PUT"
Tile_load_image ( CardSpr )
Font1.s_image.m_filename = pathf$ + "Graphics/FONTB.FNT"
Tile_load_image ( Font1 )
Font2.s_image.m_filename = pathf$ + "Graphics/FONTR.FNT"
Tile_load_image ( Font2 )

init_palette_data  pathf$ + "Graphics/another.pal" ' Load our palette.


PlaySound = TRUE
sshoot = 1


' Check if FMOD can be initiated and load all the sound effects.
IF FMODStatus = TRUE THEN
FSOUND_Init(48000, 13, 0) 
IF FSOUND_Init(48000, 13, 0) = 0 THEN 
PlaySound = FALSE
FMODStatus = FALSE
END IF
END IF

IF PlaySound = TRUE AND FMODStatus = TRUE THEN
mysamples(1) = FSOUND_Sample_Load(1, "Sound/click1.wav", 0, 0, 0) 
mysamples(2) = FSOUND_Sample_Load(2, "Sound/click2.wav", 0, 0, 0)
mysamples(3) = FSOUND_Sample_Load(3, "Sound/swing.wav", 0, 0, 0)
mysamples(4) = FSOUND_Sample_Load(4, "Sound/bluewins.ogg", 0, 0, 0)
mysamples(5) = FSOUND_Sample_Load(5, "Sound/redwins.ogg", 0, 0, 0)
mysamples(6) = FSOUND_Sample_Load(6, "Sound/atie.ogg", 0, 0, 0)
mysamples(7) = FSOUND_Sample_Load(7, "Sound/roundcomp.ogg", 0, 0, 0)
mysamples(9) = FSOUND_Sample_Load(9, "Sound/click3.wav", 0, 0, 0)
mysamples(8) = FSOUND_Stream_Open("Sound/backsound.ogg", FSOUND_LOOP, 0, 0)
FSOUND_Stream_SetMode(mysamples(8), FSOUND_LOOP_NORMAL)
FSOUND_Stream_Play(8, mysamples(8))
END IF

' Execute the main menu code.
DoMenu

SUB About
    
CLS
DO
getmouse mx, my, , buttons
PUT (0, 0), backimage(6,0), PSET
GraphicText 4, 20, " Thank you for downloading Another World Memory!", Font2
GraphicText 4, 40, "This is a classic memory game with graphics ", Font1
GraphicText 4, 50, "from Another World.", Font1
GraphicText 4, 70, "It plays like any other memory game. You turn a", Font1
GraphicText 4, 80, "card and have to find its pair(another card with", Font1
GraphicText 4, 90, "the same image). If you are successful you get a", Font1
GraphicText 4, 100, "point, keep your turn and can flip another pair", Font1
GraphicText 4, 110, "of cards. If you fail to make a match the other", Font1
GraphicText 4, 120, "player gets to turn the cards until he makes a", Font1
GraphicText 4, 130, "mistake. Constantly the players must try to", Font1
GraphicText 4, 140, "memorize the card images in order to be more", Font1
GraphicText 4, 150, "successful. The game ends when all the card", Font1
GraphicText 4, 160, "pairs have been found.", Font1
GraphicText 4, 180, "      Click left mouse button to advance", Font1
SCREENCOPY
SCREENSYNC
SLEEP 2
LOOP UNTIL buttons = 1
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND

CLS
DO
getmouse mx, my, , buttons
PUT (0, 0), backimage(6,0), PSET
GraphicText 4, 30, "This game features 3 modes. Playing against", Font1
GraphicText 4, 40, "another player, against computer AI or solo,", Font1
GraphicText 4, 50, "where you need to clear the cards in least", Font1
GraphicText 4, 60, "amount of turns or fastest you can.", Font1
GraphicText 4, 70, "You can also choose to play on 4 different", Font1
GraphicText 4, 80, "playfield sizes and with 4 different backgrounds.", Font1
GraphicText 4, 90, "During a round you can press ESC to abort it.", Font1

GraphicText 4, 110, "Computer player randomly turns the FIRST card", Font1
GraphicText 4, 120, "but has a perfect memory. When a larger number", Font1
GraphicText 4, 130, "of cards has been turned over excellent AI", Font1
GraphicText 4, 140, "simply destroys you while other types of AI", Font1
GraphicText 4, 150, "don't use their memory algorithm all the time", Font1
GraphicText 4, 160, "which is based on a simple randomization.", Font1
SCREENCOPY
SCREENSYNC
SLEEP 2
LOOP UNTIL buttons = 1
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND

CLS
DO
getmouse mx, my, , buttons
PUT (0, 0), backimage(6,0), PSET
GraphicText 20, 40, "Another World Memory is a tribute to", Font1
GraphicText 20, 50, "ANOTHER WORLD by DELPHINE SOFTWARE,", Font1
GraphicText 20, 60, "one of the best games ever designed. If you", Font1
GraphicText 20, 70, "haven't played Another World before this", Font1
GraphicText 20, 80, "game will probably make you curious about it", Font1
GraphicText 20, 90, "and for those who have played it before this", Font1
GraphicText 20, 100, "can be a nice reminder. Another World", Font1
GraphicText 20, 110, "graphics are simply beautiful and since this", Font1
GraphicText 20, 120, "game is almost completely consisted of it", Font1
GraphicText 20, 130, "it's very enjoyable for the eyes.", Font1
GraphicText 20, 160, "Anyway, enjoy the game. ", Font2
SCREENCOPY
SCREENSYNC
SLEEP 2
LOOP UNTIL buttons = 1
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND

END SUB

SUB AI
    
' Sub that controls the computer's movement(card picking).
' Same like for human players but a randomizer draws the
' cards. AISlowDown slows down the drawing(emulates
' "thinking").

IF CardOpenMode = 3 THEN
WaitForAWhile
EXIT SUB
END IF

IF BlueRedTurn = 1 THEN EXIT SUB
IF EndGame = TRUE THEN EXIT SUB

IF CardOpenMode = 1 AND AISlowDown = 0 THEN
repeatai:
X = INT(RND * XMax) + 1
Y = INT(RND * YMax) + 1

IF Card(X, Y).Active = TRUE OR Card(X, Y).Cleared = TRUE THEN GOTO repeatai:
IF Card(X, Y).Active = FALSE AND Card(X, Y).Cleared = FALSE THEN
Card(X, Y).Active = TRUE
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(1))
ActX1 = X
ActY1 = Y
Card1 = Card(X, Y).Typ
AICard(X, Y).Typ = Card(X, Y).Typ
AISlowDown = 42
CardOpenMode = 2 'mode is now 2(opening card 2)
END IF
END IF

IF AISlowDown > 0 THEN AISlowDown = AISlowDown - 1

IF CardOpenMode = 2 AND AISlowDown = 0 THEN
repeataii:
X = INT(RND * XMax) + 1
Y = INT(RND * YMax) + 1

IF Card(X, Y).Active = TRUE OR Card(X, Y).Cleared = TRUE THEN GOTO repeataii:
IF Card(X, Y).Active = FALSE AND Card(X, Y).Cleared = FALSE THEN
Card(X, Y).Active = TRUE
AISlowDown = 22
ActX2 = X
ActY2 = Y
Card2 = Card(X, Y).Typ
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(1))
AICard(X, Y).Typ = Card(X, Y).Typ
ActivationTime = 65
CardOpenMode = 3
END IF

' For the worst AIType use AI memory only 
' 1 out of 3 times.
IF AIType = 1 THEN
BadMemory = INT(RND * 3) + 1
IF BadMemory = 1 THEN GOTO skipbadmem:
GOTO skipgoodmem:
END IF

IF AIType = 2 THEN
BadMemory = INT(RND * 2) + 1
IF BadMemory = 1 THEN GOTO skipgoodmem:
GOTO skipbadmem:
END IF

' Very good AI uses AI memory 2 out of
' 3 times.
IF AIType = 3 THEN
BadMemory = INT(RND * 3) + 1
IF BadMemory = 1 THEN GOTO skipgoodmem:
GOTO skipbadmem:
END IF


skipbadmem:
' Check the memory is there is a card in the
' AI memory same as the one drawn first.
' If one is present move back the second
' drawn card and flag as the second card
' the one from the AI memory.
FOR X2 = 1 TO XMax
FOR Y2 = 1 TO YMax
IF X2 = ActX1 AND Y2 = ActY1 THEN GOTO skipper2:
IF AICard(X2, Y2).Typ = Card1 THEN
Card(ActX2, ActY2).Active = FALSE
ActX2 = X2
ActY2 = Y2
Card2 = Card(X2, Y2).Typ
Card(X2, Y2).Active = TRUE
ActivationTime = 65
CardOpenMode = 3
END IF
skipper2:
NEXT Y2
NEXT X2

skipgoodmem:

END IF


END SUB

SUB CardDisappearLayer

' Nothing fancy. Just a sub that draws the card disappearances
' if some are active. Disappearance "life" is flagged with 
' Exploding. When Exploding > 4 the disappearance has ended.
FOR countexpl = 1 TO 5
IF CardDisappear(countexpl).Locked = TRUE THEN
IF Frame2=3 THEN CardDisappear(countexpl).Exploding = CardDisappear(countexpl).Exploding + 1
IF CardDisappear(countexpl).Exploding = 0 THEN CardDisappear(countexpl).Exploding = 1

IF CardDisappear(countexpl).Exploding > 4 THEN
CardDisappear(countexpl).Locked = FALSE
GOTO gonextex:
END IF

SELECT CASE CardDisappear(countexpl).Exploding
CASE 1
extile = 23
CASE 2
extile = 24
CASE 3
extile = 25
CASE 4
extile = 26
END SELECT

PUT ((CardDisappear(countexpl).PosX), (CardDisappear(countexpl).PosY)), @CardSpr.s_image.p_data[CardSpr.s_image.p_dataindex[extile-1]], TRANS

END IF

gonextex:
NEXT countexpl

END SUB


SUB ClickBoxes
    
' Main "card to mouse cursor" clicking sub for human player one
' and human player two.

' If it's red player's turn and game mode is 1(versus CPU)
' exit this sub(use AI for the second player).
IF BlueRedTurn = 2 AND GameMode = 1 THEN EXIT SUB

' If cardopenmode = 3(second card has been draw) allow 
' next movement after certain amount of time has passed
' (flagged with ActivationTime).
IF CardOpenMode = 3 THEN
WaitForAWhile
EXIT SUB
END IF

' Don't allow the next click if the player didn't
' released the click from the last time(the click 
' is released in DoGame sub when none of the
' mouse buttons is being hold).
IF ClickControl = TRUE THEN EXIT SUB

' If the player has clicked and cardopenmode = 1(drawing
' the first card) check which card has been clicked
' and store this data in ActX1, ActY1 and Card1
' variables.
IF buttons = 1 AND CardOpenMode = 1 THEN
FOR X = 1 TO XMax
FOR Y = 1 TO YMax
    
IF mx> (Xstart + X * 27) and my> (YStart + Y * 27) and mx< (Xstart + X * 27) + 25 and my< ((YStart + Y * 27) + 25) THEN
' Open the card only if it's not opened(not really possible since this
' it the first card we are drawing but nevertheless) and not cleared.
IF Card(X, Y).Active = FALSE AND Card(X, Y).Cleared = FALSE THEN
Card(X, Y).Active = TRUE
ClickControl = TRUE
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(1))
ActX1 = X
ActY1 = Y
Card1 = Card(X, Y).Typ
' This is for computer AI(opened cards are stored in his
' memory - AICard array).
AICard(X, Y).Typ = Card(X, Y).Typ
CardOpenMode = 2  'Card mode is now 2(drawing the second card).
EXIT SUB
END IF
END IF

NEXT Y
NEXT X
END IF

' If the player has clicked and the card mode is 2
' (second card is being drawn) check which card has been 
' clicked and store this data in ActX2, ActY2 and Card2
' variables.
IF buttons = 1 AND CardOpenMode = 2 THEN
FOR X = 1 TO XMax
FOR Y = 1 TO YMax
    
IF mx> (Xstart + X * 27) and my> (YStart + Y * 27) and mx< (Xstart + X * 27) + 25 and my< ((YStart + Y * 27) + 25) THEN    
ClickControl = TRUE

IF Card(X, Y).Active = TRUE AND Card(X, Y).Cleared = FALSE THEN IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(2))
' If the clicked card is not drawn in the first drawing and
' if it's not cleared activate it and store this data in
' ActX2, ActY2 and Card2.
IF Card(X, Y).Active = FALSE AND Card(X, Y).Cleared = FALSE THEN
Card(X, Y).Active = TRUE
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(1))
ActX2 = X
ActY2 = Y
Card2 = Card(X, Y).Typ
AICard(X, Y).Typ = Card(X, Y).Typ
ActivationTime = 65-soloreduce
CardOpenMode = 3
END IF

END IF

NEXT Y
NEXT X
END IF

END SUB


SUB DoGame

starttime = TIMER&

' Main game loop.

DO
    
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_Update  

getmouse mx, my, , buttons

' This counts seconds for solo challenge mode.
IF starttime + 0.1 <= TIMER& THEN
'FPS2 = FPS
'FPS = 0
IF EndGame = FALSE THEN milsec = milsec + 1
IF milsec > 9 THEN
Seconds = Seconds + 1
milsec = 0
END IF
IF Seconds>59 THEN
Seconds = 0
Minutes = Minutes + 1
END IF
starttime = TIMER&
END IF

Frame2 = (Frame2 MOD 6) + 1

' Pastes the background.
PUT (0, 0), backimage(BackGroundType+1,0), PSET
        
ClickBoxes         ' Check if the player has clicked on any
                   ' of the cards.
                   
CardDisappearLayer ' Pastes card disappearances if any are
                   ' disappearing(being cleared).

DrawCards ' Draws the cards.
PutText   ' Pastes text(according to status in a round).

' If it's red player's turn and you are playing against the 
' computer use AI.
IF BlueRedTurn = 2 AND GameMode = 1 THEN AI

' Pastes the mouse cursor.
PUT (mx,my), @CursorSpr.s_image.p_data[CursorSpr.s_image.p_dataindex[currentcursor-1]], TRANS
'GraphicText 0,0, STR$(starttime - temptime), Font2

SCREENCOPY
SCREENSYNC
SLEEP 2

IF MULTIKEY(SC_S) THEN
BSAVE "screenshot"+LTRIM$(RTRIM$(STR$(sshoot)))+".bmp", 0, 64000
sshoot=sshoot+1
WHILE MULTIKEY(SC_S)
WEND
END IF

' The next 3 lines of code reset the ClickControl
' variable only when the player has released
' the left mouse button. When ClickControl = TRUE
' the player is not able to click on anything(check
' ClickBoxes sub).
IF buttons = 1 THEN GOTO skipclick:
ClickControl = FALSE
skipclick:

' If a round has ended and the player right clicks exit this loop
' and play a click sound.
IF EndGame = TRUE AND buttons = 2 THEN 
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
EXIT SUB
END IF

LOOP UNTIL MULTIKEY(SC_ESCAPE)

END SUB


SUB DoMenu

' Default game parameters.
' Good AI, 6*4 field size,
' human vs CPU mode,
' use background 1.
AIType = 2
AISlowDown = 0
FieldType = 2
GameMode = 1
BackGroundType = 1

mainmenu:  

DO
    
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_Update 

getmouse mx, my, , buttons

' Paste the background.
PUT (0, 0), backimage(1,0), PSET

' The next IFs with mx and my variables just check on which
' option the mouse cursor is and execute and action if the
' player clicks.

IF mx > 230-3 and my > 100-1 and mx < 309+20 and my < 107 THEN
GraphicText 218-3, 100, "*", Font1
IF buttons = 1 THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
' Before each new game reset all the game
' variables.
InitVariables
DoGame
' When a round ends and GameMode = 3(solo challenge mode)
' go to WriteHighScore sub.
IF EndGame = TRUE AND GameMode = 3 THEN WriteHighScore
CLS
GOTO mainmenu: 
END IF
END IF

IF mx > 230-3 and my > 110-1 and mx < 284+20 and my < 117 THEN
GraphicText 218-3, 110, "*", Font1
IF buttons = 1 THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND
Options
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND
CLS
GOTO mainmenu:
END IF
END IF

IF mx> 230-3 and my> 120-1 and mx< 269+20 and my< 127 THEN
GraphicText 218-3, 120, "*", Font1
IF buttons = 1 THEN
IF FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND
About
CLS
GOTO mainmenu:
END IF
END IF

IF mx>230-3 and my> 130-1 and mx< 301+20 and my< 137 THEN
GraphicText 218-3, 130, "*", Font1
IF buttons = 1 THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND
ReadHighScore 1
CLS
GOTO mainmenu:
END IF
END IF

IF mx>230-3 and my> 140-1 and mx< 261+20 and my< 147 THEN
GraphicText 218-3, 140, "*", Font2
IF buttons = 1 THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND
' Game ends - remove FMOD and clear
' memory allocated for sprites and fonts.
IF FMODStatus = TRUE THEN FSOUND_Close 
tile_destroy_image (Font1)
tile_destroy_image (Font2)
tile_destroy_image (CardSpr)
tile_destroy_image (CursorSpr)
END
END IF
END IF

GraphicText 229-3, 100, "START GAME", Font1
GraphicText 229-3, 110, "OPTIONS", Font1
GraphicText 229-3, 120, "ABOUT", Font1
GraphicText 229-3, 130, "BEST TIMES", Font1
GraphicText 229-3, 140, "EXIT", Font2

' Pastes the mouse cursor.
PUT (mx,my), @CursorSpr.s_image.p_data[CursorSpr.s_image.p_dataindex[1-1]], TRANS

SCREENCOPY
SCREENSYNC
SLEEP 2

IF MULTIKEY(SC_S) THEN
BSAVE "screenshot"+LTRIM$(RTRIM$(STR$(sshoot)))+".bmp", 0, 64000
sshoot=sshoot+1
WHILE MULTIKEY(SC_S)
WEND
END IF
    
LOOP

END SUB


SUB DrawCards
    
FOR X = 1 TO XMax
FOR Y = 1 TO YMax
IF Card(X, Y).Active = FALSE THEN currentspr = 21-addtile
IF Card(X, Y).Active = TRUE THEN currentspr = Card(X, Y).Typ

IF Card(X, Y).Cleared = FALSE THEN PUT (Xstart + (27 * X), YStart + (27 * Y)), @CardSpr.s_image.p_data[CardSpr.s_image.p_dataindex[currentspr-1+addtile]], TRANS

NEXT Y
NEXT X

END SUB


SUB InitiateCardDisappear (CardDisappearX, CardDisappearY)

' Initiates card disappearance on CardDisappearX and CardDisappearY 
' position.

' Checks for free card disappearance slot(not really necessary
' in Another World Memory) and if it's free trigger it.
FOR countexpl = 1 TO 5
IF CardDisappear(countexpl).Locked = FALSE THEN
CardDisappear(countexpl).Exploding = 0
CardDisappear(countexpl).PosX = CardDisappearX
CardDisappear(countexpl).PosY = CardDisappearY
CardDisappear(countexpl).Locked = TRUE
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(2, mysamples(3))
EXIT SUB
END IF
NEXT countexpl

END SUB

SUB InitVariables
    
' Sub that set all the game variables for
' a new game.

WHILE buttons = 1
getmouse mx, my, , buttons
SLEEP 2
WEND

' Reset all the cards.
FOR X = 1 TO 8
FOR Y = 1 TO 8
Card(X, Y).Typ = 0
Card(X, Y).Cleared = TRUE
Card(X, Y).Active = FALSE
AICard(X, Y).Typ = 0
NEXT Y
NEXT X

' According to playfield size
' flag some variables(field
' edges, number of cards, etc.)
SELECT CASE FieldType
CASE 1
Xstart = 106 - 27
YStart = 46 - 50
XMax = 4
YMax = 4
numofcards = 16
CASE 2
Xstart = 79 - 27
YStart = 46 - 50
XMax = 6
YMax = 4
numofcards = 24
CASE 3
Xstart = 52 - 27
YStart = 46 - 50
XMax = 8
YMax = 4
numofcards = 32
CASE 4
Xstart = 52 - 27
YStart = 32 - 50
XMax = 8
YMax = 5
numofcards = 40
END SELECT

EndGame = FALSE
ClickControl = FALSE
Turns = 0
CountCards = 0      ' No cards have been cleared.
BlueRedTurn = 1     ' Blue player starts first.
CardOpenMode = 1    ' First card open mode is set.
BluePoints = 0      ' Blue player points is 0.
RedPoints = 0       ' Red player points is 0.
Seconds = 0         ' Time 0:00
Minutes = 0
milsec = 0

currentcursor = 1
soloreduce = 0
IF GameMode = 3 THEN soloreduce = 10 ' In solo challenge mode cards 
                                     ' exchange faster(pauses between
                                     ' drawing are shorter). I'm using
                                     ' soloreduce variable for this.
                                     ' In other modes it's 0.

RANDOMIZE TIMER

' addtile is used to randomize the card pairs in
' playfield sizes 4*4 and 6*4(so that they are
' not the same in every game). Check DrawCards
' sub to see how it's used.
addtile= INT(RND * 3) + 1
addtile = addtile - 1
IF FieldType>2 THEN addtile = 0

' We go through all the cards and randomize their
' images. If the number of cards is 16(playfield
' 4*4) each card is flagged with a number
' from 1 to 16(this is stored in Card.Typ).
' Each card which "carries" a number above
' 8(in 4*4 playfield) needs to be reduced
' by 8 so it can be paired up with cards
' that "carry" numbers under 9. A quite
' clever way to create pairs, if I may
' say so.
FOR X1 = 1 TO XMax
FOR Y1 = 1 TO YMax
Card(X1, Y1).Active = FALSE
Card(X1, Y1).Cleared = FALSE
repeatrnd:
Card(X1, Y1).Typ = INT(RND * numofcards) + 1
FOR X2 = 1 TO XMax
FOR Y2 = 1 TO YMax
IF X2 = X1 AND Y2 = Y1 THEN GOTO skipper:
IF Card(X1, Y1).Typ = Card(X2, Y2).Typ THEN GOTO repeatrnd:
skipper:
NEXT Y2
NEXT X2
NEXT Y1
NEXT X1

' This pairs up the cards with image numbers above numofcards/2
' with cards with image numbers below numofcards/2+1.
FOR X1 = 1 TO XMax
FOR Y1 = 1 TO YMax
IF Card(X1, Y1).Typ > (numofcards / 2) THEN Card(X1, Y1).Typ = Card(X1, Y1).Typ - (numofcards / 2)
NEXT Y1
NEXT X1

END SUB


SUB Options
    
' Uncommented sub but nothing educational in it.
' A lot of dirty code.

ClickControl = TRUE

DO

PUT (0, 0), backimage(6,0), PSET

getmouse mx, my, , buttons

SELECT CASE FieldType
CASE 1
Fieldsize$ = " 4x4"
CASE 2
Fieldsize$ = " 6x4"
CASE 3
Fieldsize$ = " 8x4"
CASE 4
Fieldsize$ = " 8x5"
END SELECT

SELECT CASE BackGroundType
CASE 1
Back$ = " The Car"
CASE 2
Back$ = " The Lab"
CASE 3
Back$ = " The Bath"
CASE 4
Back$ = " The City"
END SELECT

SELECT CASE GameMode
CASE 1
Ply$ = " Human Vs Computer"
CASE 2
Ply$ = " Human Vs Human"
CASE 3
Ply$ = " Solo Challenge"
END SELECT

SELECT CASE AIType
CASE 1
Aidif$ = " Dumb"
CASE 2
Aidif$ = " Good"
CASE 3
Aidif$ = " Very Good"
CASE 4
Aidif$ = " Excellent"
END SELECT

IF FMODStatus = FALSE THEN PlaySound = FALSE
IF PlaySound = TRUE THEN Sounds$ = " On"
IF PlaySound = FALSE THEN Sounds$ = " Off"

GraphicText 108, 60, "OPTIONS MENU", Font2

GraphicText 80, 80, "Play Mode :" + Ply$, Font1
GraphicText 80, 90, "Field size :" + Fieldsize$, Font1
GraphicText 80, 100, "Background :" + Back$, Font1
GraphicText 80, 110, "Sound :" + Sounds$, Font1
GraphicText 80, 120, "AI :" + Aidif$, Font1
GraphicText 80, 135, "Exit To Main Menu", Font1

IF mx>80 AND my>80 AND mx<230 and my<87 THEN
GraphicText 70, 80, "*", Font1
IF buttons = 1 AND ClickControl = FALSE THEN
ClickControl = TRUE
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
IF GameMode = 1 THEN
GameMode = 2
GOTO skipscnd:
END IF
IF GameMode = 2 THEN
GameMode = 3
GOTO skipscnd:
END IF
IF GameMode = 3 THEN
GameMode = 1
GOTO skipscnd:
END IF
END IF
END IF

IF mx>80 AND my>90 AND mx<200 and my<97 THEN
GraphicText 70, 90, "*", Font1
IF buttons = 1 AND ClickControl = FALSE THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
ClickControl = TRUE
IF FieldType = 1 THEN
FieldType = 2
GOTO skipscnd:
END IF
IF FieldType = 2 THEN
FieldType = 3
GOTO skipscnd:
END IF
IF FieldType = 3 THEN
FieldType = 4
GOTO skipscnd:
END IF
IF FieldType = 4 THEN
FieldType = 1
GOTO skipscnd:
END IF
END IF
END IF

IF mx>80 AND my>100 AND mx<190 and my<107 THEN
GraphicText 70, 100, "*", Font1
IF buttons = 1 AND ClickControl = FALSE THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
ClickControl = TRUE
IF BackGroundType = 1 THEN
BackGroundType = 2
GOTO skipscnd:
END IF
IF BackGroundType = 2 THEN
BackGroundType = 3
GOTO skipscnd:
END IF
IF BackGroundType = 3 THEN
BackGroundType = 4
GOTO skipscnd:
END IF
IF BackGroundType = 4 THEN
BackGroundType = 1
GOTO skipscnd:
END IF
END IF
END IF

IF mx>80 AND my>110 AND mx<170 and my<117 THEN
GraphicText 70, 110, "*", Font1
IF buttons = 1 AND ClickControl = FALSE THEN
ClickControl = TRUE
IF PlaySound = TRUE THEN
IF FMODStatus = TRUE THEN FSOUND_Stream_Close(mysamples(8))
PlaySound = FALSE
GOTO skipscnd:
END IF
IF PlaySound = FALSE THEN
IF FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
IF FMODStatus = TRUE THEN
mysamples(8) = FSOUND_Stream_Open("Sound/backsound.ogg", FSOUND_LOOP, 0, 0)
FSOUND_Stream_SetMode(mysamples(8), FSOUND_LOOP_NORMAL)
FSOUND_Stream_Play(8, mysamples(8))
PlaySound = TRUE
END IF
GOTO skipscnd:
END IF
END IF
END IF

IF mx>80 AND my>120 AND mx<170 and my<127 THEN
GraphicText 70, 120, "*", Font1
IF buttons = 1 AND ClickControl = FALSE THEN
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
ClickControl = TRUE
IF AIType = 1 THEN
AIType = 2
GOTO skipscnd:
END IF
IF AIType = 2 THEN
AIType = 3
GOTO skipscnd:
END IF
IF AIType = 3 THEN
AIType = 4
GOTO skipscnd:
END IF
IF AIType = 4 THEN
AIType = 1
GOTO skipscnd:
END IF
END IF
END IF

IF mx>80 AND my>135 AND mx<220 and my<142 THEN
GraphicText 70, 135, "*", Font1
IF buttons = 1 AND ClickControl = FALSE THEN 
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
EXIT SUB
ClickControl = TRUE
END IF
END IF

skipscnd:
IF buttons = 1 THEN GOTO skipclick2:
ClickControl = FALSE
skipclick2:

' Paste the mouse cursor
PUT (mx,my), @CursorSpr.s_image.p_data[CursorSpr.s_image.p_dataindex[1-1]], TRANS

SCREENCOPY
SCREENSYNC
SLEEP 2

IF MULTIKEY(SC_S) THEN
BSAVE "screenshot"+LTRIM$(RTRIM$(STR$(sshoot)))+".bmp", 0, 64000
sshoot=sshoot+1
WHILE MULTIKEY(SC_S)
WEND
END IF

LOOP UNTIL buttons = 2

END SUB

SUB PutText
    
' Pastes text on the screen according to game mode
' and status in a round(if it's ended or not).

IF GameMode < 3 THEN
IF BlueRedTurn = 1 THEN
currentcursor = 1
GraphicText 93, 180, " Blue player's turn", Font1
END IF

IF BlueRedTurn = 2 THEN
currentcursor = 2
IF GameMode = 1 THEN currentcursor = 3
GraphicText 91, 180, "  Red player's turn", Font2
END IF

GraphicText 0, 180, "Blue player", Font1
GraphicText 0, 190, "  * " + STR$(BluePoints), Font1

GraphicText 250, 180, "Red player", Font2
GraphicText 250, 190, "  * " + STR$(RedPoints), Font2

IF EndGame = TRUE THEN
currentcursor = 1
IF BluePoints > RedPoints THEN GraphicText 115, 80, "Blue player wins!", Font1
IF BluePoints < RedPoints THEN GraphicText 115, 80, "Red player wins!", Font2
IF BluePoints = RedPoints THEN GraphicText 115, 80, "    A tie!    ", Font2
GraphicText 57, 100, "Right click to return to main menu", Font1
END IF
END IF

IF GameMode = 3 THEN
GraphicText 100, 180, "  Solo Challenge", Font2
IF Minutes<10 THEN addmin$="0"
IF Seconds<10 THEN addsec$="0"
GraphicText 0, 180, "Time: " + addmin$+ STR$(Minutes)+":"+addsec$+STR(Seconds)+ "." + STR$(milsec), Font1
GraphicText 240, 180, "Turns: " + STR$(Turns), Font1
IF EndGame = TRUE THEN
Seconds2 = Seconds+Minutes*60
GraphicText 87, 80, "You needed " + STR$(Seconds2) + "." + STR$(milsec)+" seconds or", Font2
SELECT CASE FieldType
CASE 1
Fieldsize$ = " 4x4"
CASE 2
Fieldsize$ = " 6x4"
CASE 3
Fieldsize$ = " 8x4"
CASE 4
Fieldsize$ = " 8x5"
END SELECT
GraphicText 85, 90, STR$(Turns) + " turns to finish a" + Fieldsize$, Font2
GraphicText 87, 100, "     sized field.", Font2
GraphicText 57, 120, "Right click to return to main menu", Font2
END IF
END IF

END SUB

SUB WaitForAWhile

' Sub which is executed when CardOpenMode = 3 and
' CardOpenMode = 3 when the second card has
' been drawn. Checks if the drawn cards are
' the same or not.
    
ActivationTime = ActivationTime - 1
IF ActivationTime = 0 THEN
' If some time has passed(flagged with
' ActivationTime) count the number of 
' turns and return to card mode 1.
Turns = Turns + 1
CardOpenMode = 1
Card(ActX1, ActY1).Active = FALSE
Card(ActX2, ActY2).Active = FALSE
ClickControl = TRUE
END IF

' If Card1 = Card2(drawn cards are the same)
' count the number of cleared pairs and add
' points to the player who has been
' drawing(flagged with BlueRedTurn variable).
IF Card1 = Card2 AND ActivationTime = 0 THEN
CountCards = CountCards + 1
IF BlueRedTurn = 1 THEN BluePoints = BluePoints + 1
IF BlueRedTurn = 2 THEN RedPoints = RedPoints + 1

' If the number of cleared pairs(flagged with
' CountCards) equals HALF the number of
' total cards(set before each game according
' to playfield size) play a sound according
' to game mode.
IF CountCards = numofcards / 2 THEN
IF GameMode<3 THEN
IF BluePoints > RedPoints AND PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(3, mysamples(4))
IF BluePoints < RedPoints AND PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(3, mysamples(5))
IF BluePoints = RedPoints AND PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(3, mysamples(6))
END IF
IF GameMode=3 AND PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(3, mysamples(7))
EndGame = TRUE
END IF

' Since the drawn cards are the same clear them out and
' animate their disappearance with InitiateCardDisappear sub.
Card(ActX1, ActY1).Cleared = TRUE
Card(ActX2, ActY2).Cleared = TRUE
InitiateCardDisappear Xstart + ActX1 * 27, YStart + ActY1 * 27
InitiateCardDisappear Xstart + ActX2 * 27, YStart + ActY2 * 27
END IF

' If the drawn cards are not the same pass the turn
' to the second player(flagged with BlueRedTurn).
' BlueRedTurn = 1 -> blue player is drawing
' BlueRedTurn = 2 -> red player is drawing
IF Card1 <> Card2 AND ActivationTime = 0 THEN
IF BlueRedTurn = 2 THEN
BlueRedTurn = 1
EXIT SUB
END IF
IF BlueRedTurn = 1 THEN
BlueRedTurn = 2
AISlowDown = 0
IF GameMode = 1 THEN AISlowDown = 22
IF GameMode = 3 THEN BlueRedTurn = 1
EXIT SUB
END IF
END IF

END SUB


SUB GraphicText (xx, yy, Textt$, tile as tileType)
'* GraphicText() subroutine:
'* Displays a text string at a graphics screen coordinate, using a bitmapped
'* character set.
'*
'* Parameters:
'*           xx - Horizontal coordinate of where printing should start or:
'*                Use CENTRETEXT to have the text centred.
'*           yy - Vertical coordinate of where printing should start.        
'*        Textt$ - The text string to be displayed.
'*        tile - Image array holding the character set to be used. Each
'*               character must in the standard ASCII order, starting with
'*               the space character(in the PUT file).
   
    MessLen = LEN(Textt$)

    ' Get character's sprite depth.
    CharDepth = GetDepth(1,tile)

    ' Loop to display each character of Text$.
    FOR n = 1 TO MessLen
        CharNo = ASC(MID$(Textt$, n, 1)) - 32
        CharWidth = GetWidth(CharNo, tile)
    ' Put the character on the screen.
        PUT (xx, yy), @Tile.s_image.p_data[Tile.s_image.p_dataindex[CharNo]], TRANS

        xx = xx + CharWidth
    NEXT n


END SUB


FUNCTION GetDepth (ImNo,tilem as tileType)
' Function used to acquire depth of a character sprite
' (due the R.E.Lope's method used to store and display sprites
' on the screen I have to use this lame way to get the sprite
' depth). This code is pending for correction.
' Only one error can appear with this sub; if you use the last
' character from your font set. So just create one image behind your
' last character in the font set in PP256 of any size(ie, 1*1).
    GetDepth = @Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo+1]]-@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo]]

END FUNCTION

FUNCTION GetWidth (ImNo,tilem as tileType)
' Function used to acquire width of a character sprite
' (due the R.E.Lope's method used to store and display sprites
' on the screen I have to use this lame way to get the sprite
' depth). This code is pending for correction.
' Only one error can appear with this sub; if you use the last
' character from your font set. So just create one image behind your
' last character in the font set in PP256 of any size(ie, 1*1).

    ' FreeBASIC versions before 0.15
    'GetWidth = (@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo+1]]-@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo]])/8
     
    ' FreeBASIC versions after 0.14
    GetWidth = (@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo+1]]-@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo]])/4
     

END FUNCTION

SUB tile_load_image ( tile as tileType )
' Sub used to load PUT files(relates to pp256_image.bi module).
' Don't break your head over it unless you are interested in
' modifying the way your program relates to pp256_image.bi
' module or the very module.
	
   tile.s_image.init = @image_init
   tile.s_image.init ( tile.s_image )
   tile.s_image.Load ( tile.s_image )
   tile.s_image.Index ( tile.s_image )
	
END SUB

SUB tile_destroy_image ( tiled as tileType )

   tiled.s_image.destroy ( tiled.s_image )
	
END SUB

SUB WriteHighScore
    
' Some really dirty code for new high score
' inputting. It checks the proper high
' score table(according to playfield) and
' if the lowest score has been exceeded
' (LESS THAN in Another World Memory)
' input new score(call InputName sub).
' Encryption codes HAVE BEEN CHANGED
' so don't try to use them to decrypt
' the default game scores.

REDIM scores(4) AS SINGLE
REDIM textarray(9) AS STRING
REDIM plscore AS SINGLE
datafile$ = "data/hs"+STR$(FieldType)+".DAT"
OPEN path$ + datafile$ FOR INPUT AS #3
FOR tar = 1 TO 8
INPUT #3, textarray(tar)
neoENCdepass SADD(textarray(tar)), LEN(textarray(tar)), "gonaria"
NEXT tar
CLOSE #3

FOR ar = 5 TO 8
ar2 = ar - 4
scores(ar2) = VAL(textarray(ar))
NEXT ar

plscore = Seconds+Minutes*60+(0.1*milsec)

IF plscore < scores(4) THEN

FOR nameloop = 1 TO 4
IF plscore < scores(nameloop) THEN

WHILE MULTIKEY(SC_Y)
WEND

DO
    
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_Update 
PUT (0, 0), backimage(6,0), PSET
getmouse mx, my, , buttons
GraphicText 65, 93, "ENTER NEW TIME SCORE(Y/N)?", Font2
IF MULTIKEY(SC_N) THEN 
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
EXIT SUB
END IF
SCREENCOPY
SCREENSYNC
sleep 2
LOOP UNTIL MULTIKEY(SC_Y)
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))

InputName
highname$ = playername$
startwrite = nameloop
GOTO writescore:
END IF
NEXT nameloop

writescore:
IF startwrite = 4 THEN GOTO writescore2:
FOR m = 3 TO startwrite STEP -1
n = m + 1
textarray(n) = textarray(m)
scores(n) = scores(m)
NEXT m
writescore2:
scores(startwrite) = plscore
textarray(startwrite) = highname$

FOR ar = 5 TO 8
ar2 = ar - 4
textarray(ar) = LTRIM$(STR$(scores(ar2)))
NEXT ar

OPEN path$ + datafile$ FOR OUTPUT AS #3
FOR tar = 1 TO 8
neoENCpass SADD(textarray(tar)), LEN(textarray(tar)), "gonaria"
PRINT #3, textarray(tar)
NEXT tar
CLOSE #3

' After a new score has been inputted display the
' high score tables.
ReadHighScore FieldType

END IF

END SUB


SUB InputName
    
' The name inputting sub originally 
' made by Ryan Szrama. I found it useful 
' so might you.

' inputted name is stored in playername$
' string and each letter in playerletter$(letnum)
' strings.

WHILE INKEY$ <> "": WEND

' Reset the name to input and
' letters to input(might some
' be in memory from the
' last inputting.
playername$=""
countlet=1
for playl=1 to 8
playerletter$(playl)=""
next playl

do ' Main inputting loop.

getmouse mx, my, , buttons

PUT (0, 0), backimage(6,0), PSET

blinker$=" "
Frame4 = (Frame4 mod 16) + 1
if Frame4>8 and countmenu=0 then blinker$="_"
a$ = INKEY$   

if countmenu=0 then
if asc(ucase$(a$)) >= 65 and asc(ucase$(a$)) <= 90 and countlet<9 then
playerletter$(countlet) = UCASE$(a$)
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
countlet=countlet+1
end if
if asc(a$) = 8 and countlet > 1 then
IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))
countlet=countlet-1
playerletter$(countlet) = ""
end if
end if

playername$=""
' Add each letter to the playername$ string.
for countpname=1 to 8
playername$=playername$+playerletter$(countpname)
next countpname

GraphicText 86,60, "Please enter your name:", Font2
GraphicText 125,80, playername$+blinker$, Font2

screencopy   
SCREENSYNC   
sleep 2

' End name inputting when the player has
' clicked ENTER and at least one letter has been
' inputted.
LOOP UNTIL MULTIKEY(SC_ENTER) AND countlet>1

IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))


END SUB

SUB ReadHighScore (hft)
    
' Nothing educational in this sub. It pastes the
' high score tables.

Frame2 = 0

WHILE MULTIKEY(SC_ENTER) OR buttons = 1
getmouse mx, my, , buttons
PUT (0, 0), backimage(6,0), PSET
WEND

REDIM textarray(9) AS STRING

HFieldType = hft
datafile$ = "data/hs"+STR$(HFieldType)+".DAT"
OPEN path$ + datafile$ FOR INPUT AS #3
FOR tar = 1 TO 8
INPUT #3, textarray(tar)
neoENCdepass SADD(textarray(tar)), LEN(textarray(tar)), "gonaria"
NEXT tar
CLOSE #3

DO

IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_Update 
    
Frame2 = (Frame2 MOD 200) + 1
IF Frame2 = 199 THEN 
HFieldType = HFieldType + 1
IF HFieldType > 4 THEN HFieldType = 1
datafile$ = "data/hs"+STR$(HFieldType)+".DAT"
OPEN path$ + datafile$ FOR INPUT AS #3
FOR tar = 1 TO 8
INPUT #3, textarray(tar)
neoENCdepass SADD(textarray(tar)), LEN(textarray(tar)), "gonaria"
NEXT tar
CLOSE #3
END IF

getmouse mx, my, , buttons
PUT (0, 0), backimage(6,0), PSET

SELECT CASE HFieldType
CASE 1
Fieldsize$ = "Field Size 4x4"
CASE 2
Fieldsize$ = "Field Size 6x4"
CASE 3
Fieldsize$ = "Field Size 8x4"
CASE 4
Fieldsize$ = "Field Size 8x5"
END SELECT

GraphicText 105, 10, "SOLO CHALLENGE", Font2

GraphicText 54, 30, "Fastest Brains - "+Fieldsize$, Font2

FOR tar = 1 TO 4
GraphicText 80, 50 + tar * 12, textarray(tar),Font1
NEXT tar
FOR ar = 5 TO 8
GraphicText 161, 50 + (ar - 4) * 12, textarray(ar)+" Seconds", Font2
NEXT ar

GraphicText 28, 170, "Press enter or left mouse click to exit", Font2

SCREENCOPY
SCREENSYNC
SLEEP 2

IF MULTIKEY(SC_S) THEN
BSAVE "screenshot"+LTRIM$(RTRIM$(STR$(sshoot)))+".bmp", 0, 64000
sshoot=sshoot+1
WHILE MULTIKEY(SC_S)
WEND
END IF

LOOP UNTIL MULTIKEY(SC_ENTER) OR buttons = 1

IF PlaySound = TRUE AND FMODStatus = TRUE THEN FSOUND_PlaySound(1, mysamples(9))

WHILE MULTIKEY(SC_ENTER) OR buttons = 1
getmouse mx, my, , buttons
PUT (0, 0), backimage(6,0), PSET
WEND

END SUB

SUB neoENCdepass (Offsett%, Lengthh&, passsword$)

' Subs used to encrypt and decrypt the high scores
' data.

   IF LEN(passsword$) = 0 THEN EXIT SUB
   nowpos% = 1

   FOR I& = 0 TO Lengthh& - 1
      Bytee% = PEEK(Offsett% + I&)
      Bytee% = Bytee% - ASC(MID$(passsword$, nowpos%, 1))
      IF Bytee% < 0 THEN Bytee% = Bytee% + 256
      POKE Offsett% + I&, Bytee%
      nowpos% = nowpos% + 1
      IF nowpos% > LEN(passsword$) THEN nowpos% = 1
   NEXT I&

END SUB

SUB neoENCpass (Offset%, Length&, password$)
   IF LEN(password$) = 0 THEN EXIT SUB

   nowpos% = 1
   
   FOR I& = 0 TO Length& - 1
      Bytee% = PEEK(Offset% + I&)
      Bytee% = Bytee% + ASC(MID$(password$, nowpos%, 1))
      IF Bytee% > 255 THEN Bytee% = Bytee% - 256
      POKE Offset% + I&, Bytee%
      nowpos% = nowpos% + 1
      IF nowpos% > LEN(password$) THEN nowpos% = 1
   NEXT I&

END SUB
