DEFINT A-Z

#include "fbgfx.bi"
#include "pp256_image.bi" 

' Variables and the sub used to load PUT files into arrays.
TYPE tileType
s_image	    as ImageType		
init	  	    as sub ( byref tile as tileType )	 
load_image   as sub ( byref tile as tileType )	  
END TYPE
DECLARE SUB tile_load_image ( byref tile as tileType )
DECLARE SUB tile_destroy_image ( byref tiled as tileType )
'***********************************************

' Subs used to print custom font text on the screen.
DECLARE SUB GraphicText (xx%, yy%, Textt$, byref tile as tileType)
DECLARE FUNCTION GetDepth% (ImNo%,byref tilem as tileType)
DECLARE FUNCTION GetWidth% (ImNo%,byref tilem as tileType)

CONST FALSE = 0
CONST TRUE = 1
CONST NULL = 0

DIM SHARED Font1 as tileType
DIM SHARED Font2 as tileType
DIM SHARED backimage(64004) AS INTEGER

OPEN pathf$ + "data/setup.dat" FOR INPUT AS #2
INPUT #2, FullScreen
INPUT #2, FMODStatus
CLOSE #2


SCREEN 13, 8, 2, 0
SCREENSET 1, 0
SETMOUSE 0,0,0

WHILE MULTIKEY(SC_ENTER)
WEND

EnterPressed=FALSE

pathf$ = ""

Font1.s_image.m_filename = pathf$ + "Graphics/FONTB.FNT"
Tile_load_image ( Font1 )
Font2.s_image.m_filename = pathf$ + "Graphics/FONTR.FNT"
Tile_load_image ( Font2 )

BLOAD "Graphics/BACKG5.bmp", 0
GET (0,0)-(319,199), backimage(0)

init_palette_data  pathf$ + "Graphics/ANOTHER.PAL"

YPoss=1

MovPress = TRUE
    
DO


IF MULTIKEY(SC_DOWN) AND MovPress = TRUE THEN 
YPoss=YPoss+1
MovPress = FALSE
IF YPoss>3 THEN 
YPoss=3
GOTO skipn:
END IF
END IF
IF MULTIKEY(SC_UP) AND MovPress = TRUE THEN 
YPoss=YPoss-1
MovPress = FALSE
IF YPoss<1 THEN 
YPoss=1
GOTO skipn:
END IF
END IF


IF MULTIKEY(SC_ENTER) AND EnterPressed = FALSE THEN
EnterPressed = TRUE

SELECT CASE YPoss
CASE 1
IF FullScreen = 1 THEN 
FullScreen = 0
GOTO skipn:
END IF
IF FullScreen = 0 THEN 
FullScreen = 1
GOTO skipn:
END IF
CASE 2
IF FMODStatus = TRUE THEN
FMODStatus = FALSE
GOTO skipn:
END IF
IF FMODStatus = FALSE THEN
FMODStatus = TRUE
GOTO skipn:
END IF 
CASE 3
OPEN pathf$ + "data/setup.dat" FOR OUTPUT AS #2
PRINT #2, FullScreen
PRINT #2, FMODStatus
CLOSE #2
tile_destroy_image (Font1)
tile_destroy_image (Font2)
END
END SELECT

END IF

IF MULTIKEY(SC_ENTER) OR MULTIKEY(SC_DOWN) OR MULTIKEY(SC_UP) THEN GOTO skipn:
EnterPressed=FALSE
MovPress = TRUE
skipn:

flscr$="NO"
shut$="YES"
IF FullScreen = 1 THEN flscr$="YES"
IF FModStatus = TRUE THEN shut$="NO"

SELECT CASE YPoss
CASE 1
YPointPos = 80
CASE 2
YPointPos = 90
CASE 3
YPointPos = 105
END SELECT

PUT (0,0), backimage(0), PSET

GraphicText 68, YPointPos ,">", Font1
GraphicText 70,40, "Another World Memory Setup", Font2
GraphicText 80,80, "Fullscreen mode: "+flscr$, Font2
GraphicText 80,90, "Disable sound/music: "+shut$, Font2
GraphicText 80,105, "Quit and save", Font2

SCREENCOPY
SCREENSYNC
sleep 2
LOOP

SUB tile_load_image ( tile as tileType )
' Sub used to load PUT files(relates to pp256_image.bi module).
' Don't break your head over it unless you are interested in
' modifying the way your program relates to pp256_image.bi
' module or the very module.
	
   tile.s_image.init = @image_init
   tile.s_image.init ( tile.s_image )
   tile.s_image.Load ( tile.s_image )
   tile.s_image.Index ( tile.s_image )
	
END SUB

SUB GraphicText (xx, yy, Textt$, tile as tileType)
'* GraphicText() subroutine:
'* Displays a text string at a graphics screen coordinate, using a bitmapped
'* character set.
'*
'* Parameters:
'*           xx - Horizontal coordinate of where printing should start or:
'*                Use CENTRETEXT to have the text centred.
'*           yy - Vertical coordinate of where printing should start.        
'*        Textt$ - The text string to be displayed.
'*        tile - Image array holding the character set to be used. Each
'*               character must in the standard ASCII order, starting with
'*               the space character(in the PUT file).
   
    MessLen = LEN(Textt$)

    ' Get character's sprite depth.
    CharDepth = GetDepth(1,tile)

    ' Loop to display each character of Text$.
    FOR n = 1 TO MessLen
        CharNo = ASC(MID$(Textt$, n, 1)) - 32
        CharWidth = GetWidth(CharNo, tile)
    ' Put the character on the screen.
        PUT (xx, yy), @Tile.s_image.p_data[Tile.s_image.p_dataindex[CharNo]], TRANS

        xx = xx + CharWidth
    NEXT n

END SUB


FUNCTION GetDepth (ImNo,tilem as tileType)
' Function used to acquire depth of a character sprite
' (due the R.E.Lope's method used to store and display sprites
' on the screen I have to use this lame way to get the sprite
' depth). This code is pending for correction.
' Only one error can appear with this sub; if you use the last
' character from your font set. So just create one image behind your
' last character in the font set in PP256 of any size(ie, 1*1).
    GetDepth = @Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo+1]+1]-@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo]+1]

END FUNCTION

FUNCTION GetWidth (ImNo,tilem as tileType)
' Function used to acquire width of a character sprite
' (due the R.E.Lope's method used to store and display sprites
' on the screen I have to use this lame way to get the sprite
' depth). This code is pending for correction.
' Only one error can appear with this sub; if you use the last
' character from your font set. So just create one image behind your
' last character in the font set in PP256 of any size(ie, 1*1).

   GetWidth = (@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo+1]]-@Tilem.s_image.p_data[Tilem.s_image.p_dataindex[ImNo]])/4

END FUNCTION

SUB tile_destroy_image ( tiled as tileType )

   tiled.s_image.destroy ( tiled.s_image )
	
END SUB

